include:
  - project: 'numbereight/operations/ci-scripts'
    file: '/ios/ci.yml'

stages:
  - prepare
  - fetch
  - update
  - deploy NumberEightCompiled
  - deploy NumberEightCore

# TODO: Push shared NumberEight.podspec
variables:
  GIT_DEPTH: 1
  NUMBEREIGHTCOMPILED_PODSPEC: NumberEightCompiledBeta.podspec
  NUMBEREIGHT_PODSPEC: NumberEightCoreBeta.podspec

#
# Gets the job ID from the upstream pipeline.  See `Update Version` job for more information.
#
Get Assemble NumberEightCompiled (Release) Job ID:
  extends: .base-get-job-id-ios
  stage: prepare
  variables:
    NESDKIOS_DEPENDENT_JOB_NAME: "Assemble NumberEightCompiled (Release)"

#
# Gets the job ID from the upstream pipeline.  See `Update Version` job for more information.
#
Get Zip NumberEight Job ID:
  extends: .base-get-job-id-ios
  stage: prepare
  variables:
    NESDKIOS_DEPENDENT_JOB_NAME: "Zip NumberEight Source"

#
# Downloads the artifacts from the upstream pipeline for the particular job ID.
# This will make them available as artifacts to downstream jobs of this pipeline.
#
Get Artifacts NumberEightCompiled:
  extends: .base-get-job-artifacts-ios
  stage: fetch
  needs:
    - job: Get Assemble NumberEightCompiled (Release) Job ID
      artifacts: true
  artifacts:
    paths:
      - NumberEightCompiled_Release.xcframework

#
# Downloads the artifacts from the upstream pipeline for the particular job ID.
# This will make them available as artifacts to downstream jobs of this pipeline.
#
Get Artifacts NumberEight:
  extends: .base-get-job-artifacts-ios
  stage: fetch
  needs:
    - job: Get Zip NumberEight Job ID
      artifacts: true
  artifacts:
    paths:
      - NumberEight.zip

#
# Pushes the new built artifacts to the repo for deploy, and updates the podspec with the appropriate version.
#
# Usage:
#  - NESDKIOS_VERSION: the new version of the iOS SDK e.g. 3.1.4
#  - NESDKIOS_UPSTREAM_PIPELINE: The pipeline ID for the iOS SDK pipeline to pull artifacts from.  Note the jobs must have succeeded.
#
Update Version:
  extends: .base-update-repo
  stage: update
  needs:
    - job: Get Artifacts NumberEightCompiled
      artifacts: true
      optional: true
    - job: Get Artifacts NumberEight
      artifacts: true
      optional: true
  variables:
    UPDATE_VERSION: $NESDKIOS_VERSION
  rules:
    - if: $CI_PIPELINE_SOURCE == "pipeline" && $NESDKIOS_VERSION != null && $NESDKIOS_VERSION != ""
    - if: $CI_PIPELINE_SOURCE == "web" && $NESDKIOS_VERSION != null && $NESDKIOS_VERSION != ""
    - if: $CI_COMMIT_BRANCH == $CI_DEFAULT_BRANCH && $NESDKIOS_VERSION != null && $NESDKIOS_VERSION != ""
  script:
    - rm -rf NumberEightCompiled.xcframework
    - mv NumberEightCompiled_Release.xcframework NumberEightCompiled.xcframework
    - rm -rf Source
    - unzip -o NumberEight.zip
    - rm NumberEight.zip
    - version="$(cut -d '-' -f 1 <<< ${UPDATE_VERSION:1})"
    - sed -i -e "s/  spec.version = '.*'/  spec.version = '${version}'/" "$NUMBEREIGHTCOMPILED_PODSPEC"
    - sed -i -e "s/  spec.version = '.*'/  spec.version = '${version}'/" "$NUMBEREIGHT_PODSPEC"
    - git add .
    - !reference [.push-to-git, script]


#
# Pushes NumberEightCompiled to the numbereight CocoaPods repo.
# Don't push to trunk, this is the debug build.
#
Push NumberEightCompiled NE:
  extends: .basePushToCocoapods
  stage: deploy NumberEightCompiled
  variables:
    DESTINATION: "numbereight"
    PODSPEC: $NUMBEREIGHTCOMPILED_PODSPEC

#
# Pushes NumberEight to the numbereight CocoaPods repo.
# Don't push to trunk, this is the debug build.
Push NumberEightCore NE:
  extends: .basePushToCocoapods
  stage: deploy NumberEightCore
  needs:
    - job: Push NumberEightCompiled NE
      artifacts: false
  variables:
    DESTINATION: "numbereight"
    PODSPEC: $NUMBEREIGHT_PODSPEC
